"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cleanAst = void 0;
const cleanAst = (obj) => {
    var copy;
    // Handle the 3 simple types, and null or undefined
    if (null == obj || 'object' != typeof obj)
        return obj;
    // Handle Date
    if (obj instanceof Date) {
        copy = new Date();
        copy.setTime(obj.getTime());
        return copy;
    }
    // Handle Array
    if (obj instanceof Array) {
        copy = [];
        for (var i = 0, len = obj.length; i < len; i++) {
            copy[i] = (0, exports.cleanAst)(obj[i]);
        }
        return copy;
    }
    // Handle Object
    if (obj instanceof Object || typeof obj === 'object') {
        copy = {};
        for (var attr in obj) {
            if (obj.hasOwnProperty(attr)) {
                switch (attr) {
                    case 'loc':
                    case 'start':
                    case 'end':
                        // case 'parenStart':
                        // case 'extra':
                        break;
                    case 'JSXText':
                        copy[attr] = (0, exports.cleanAst)(obj[attr]);
                        // get rid of 4 extra spaces
                        // copy[attr].value.replace('    ', '');
                        break;
                    case 'StringLiteral':
                        copy[attr] = (0, exports.cleanAst)(obj[attr]);
                        // get rid of 4 extra spaces
                        copy[attr].extra.rawValue = copy[attr].extra.value;
                        copy[attr].extra.raw = `\"${copy[attr].extra.value}\"`;
                        break;
                    default:
                        copy[attr] = (0, exports.cleanAst)(obj[attr]);
                }
            }
            else {
                copy[attr] = (0, exports.cleanAst)(obj[attr]);
            }
        }
        return copy;
    }
    throw new Error("Unable to copy obj! Its type isn't supported.");
};
exports.cleanAst = cleanAst;
