"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getConfigOptions = void 0;
const generator_1 = __importDefault(require("@babel/generator"));
const utils_1 = require("../../utils");
const getConfigOptions = (path, scope) => {
    let configOptions = {};
    const expr = path.node.expression;
    if (expr.type === 'CallExpression' &&
        expr.callee.type === 'Identifier' &&
        expr.callee.name === 'useMetadata') {
        if (path.parent.type !== 'Program') {
            (0, utils_1.throwError)('bad config placement');
        }
        if (expr.arguments.length === 0) {
            (0, utils_1.throwError)('no config args');
        }
        if (expr.arguments.length !== 1) {
            (0, utils_1.throwError)('too many config args');
        }
        if (expr.arguments[0].type !== 'ObjectExpression') {
            (0, utils_1.throwError)('config must be an object');
        }
        try {
            // eval isn't always evil ;) compile time!
            eval(`configOptions = ${(0, generator_1.default)(expr.arguments[0]).code}`);
        }
        catch (e) {
            throw new Error('Genonomic Parser Error: bad config options');
        }
        path.remove();
        path.stop();
    }
    scope.configOptions = configOptions;
    return configOptions;
};
exports.getConfigOptions = getConfigOptions;
