"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseLoops = void 0;
const t = __importStar(require("@babel/types"));
const traverse_1 = __importDefault(require("@babel/traverse"));
const utils_1 = require("../../utils");
const parseLoops = (path, scope) => {
    if (path.node.openingElement.type !== 'JSXOpeningElement')
        return;
    if (path.node.openingElement.name.type !== 'JSXIdentifier')
        return;
    if (path.node.openingElement.name.name !== 'For')
        return;
    if (path.node.openingElement.attributes[0].type !== 'JSXAttribute')
        return;
    const el = path.node.openingElement.attributes[0];
    if (el.name.type !== 'JSXIdentifier')
        return;
    if (el.name.name !== 'each') {
        (0, utils_1.throwError)('For requires each prop!');
    }
    const exprContainer = el.value;
    /////
    /////
    /////
    const innerExprContainer = path.node.children.find(n => n.type === 'JSXExpressionContainer');
    // RECURSION
    // base recursion case
    if (!innerExprContainer)
        return;
    if (innerExprContainer.type !== 'JSXExpressionContainer') {
        (0, utils_1.throwError)('For requires JSXExpressionContainer!');
    }
    const innerExpr = innerExprContainer.expression;
    if (innerExpr.params.length !== 2) {
        (0, utils_1.throwError)('For requires 2 params!');
    }
    const item = innerExpr.params[0];
    const index = innerExpr.params[1];
    const body = innerExpr.body;
    const expr = t.optionalCallExpression(t.optionalMemberExpression(exprContainer.expression, t.identifier('map'), false, true), [
        t.arrowFunctionExpression([
            item,
            index
        ], body)
    ], false);
    return path.replaceWith(t.jsxExpressionContainer(expr));
    // RECURSION
    // RECURSION
    // RECURSION
    const programNode = t.file(t.program([
        t.functionDeclaration(t.identifier('fakeFunction'), [], t.blockStatement([
            t.returnStatement(
            // RECURSION
            // JSX goes here
            expr)
        ]))
    ]));
    // bake
    (0, traverse_1.default)(programNode, {
        JSXElement(returnPath) {
            (0, exports.parseLoops)(returnPath, scope);
        }
    });
    // pull out of the oven
    const funcDecl = programNode.program.body[0];
    const blockStm = funcDecl.body;
    const retnStmt = blockStm.body[0];
    const output = t.jsxExpressionContainer(retnStmt.argument);
    path.replaceWith(output);
};
exports.parseLoops = parseLoops;
