"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateRefFunctionDeclarations = exports.processForwardRefs = exports.getForwardRefs = exports.isForwardRef = exports.useRefVariableDeclarator = exports.updateRefsIdentifier = void 0;
const t = __importStar(require("@babel/types"));
const utils_1 = require("../../utils");
const component_1 = require("./component");
const updateRefsIdentifier = (path, scope) => {
    // in a MemberExpression?
    if (path.parent.type === 'MemberExpression') {
        return;
    }
    // in a VariableDeclarator?
    if (path.parent.type === 'VariableDeclarator') {
        return;
    }
    // is a ref there?
    if (!scope.currentComponent()?.hasRef(path.node.name)) {
        return;
    }
    // if a ref passing a ref to a component, leave it
    if (path.parent.type == 'JSXExpressionContainer') {
        if (path.parentPath.parent.type === 'JSXAttribute') {
            const attr = path.parentPath.parent;
            if (attr.name.name === 'ref') {
                return;
            }
        }
    }
    // if a forwardRef passing a ref to a component, leave it
    if (path.parent.type == 'LogicalExpression') {
        if (path.parentPath.parent.type == 'JSXExpressionContainer') {
            if (path.parentPath.parentPath.parent.type === 'JSXAttribute') {
                const attr = path.parentPath.parentPath.parent;
                if (attr.name.name === 'ref') {
                    return;
                }
            }
        }
    }
    path.replaceWith(t.memberExpression(t.identifier(path.node.name), t.identifier('current')));
};
exports.updateRefsIdentifier = updateRefsIdentifier;
const useRefVariableDeclarator = (path, scope) => {
    if (path.node.init &&
        path.node.init.type === 'CallExpression' &&
        path.node.init.callee &&
        path.node.init.callee.type === 'Identifier' &&
        path.node.init.callee.name === 'useRef') {
        const node = path.node;
        if (node.id.type !== 'Identifier') {
            return (0, utils_1.throwError)('useRef must use an Identifier');
        }
        if (scope.currentComponent().hasRef(node.id.name)) {
            // throwError('refs variable is already defined!')
        }
        else {
            scope.currentComponent().addRef({
                name: node.id.name
            });
        }
    }
};
exports.useRefVariableDeclarator = useRefVariableDeclarator;
const isForwardRef = (path) => {
    if (path.node.name.type === 'JSXIdentifier') {
        if (path.node.name.name !== 'ref')
            return;
        if (path.node.value.type === 'JSXExpressionContainer') {
            if (path.node.value.expression.type === 'MemberExpression') {
                if (path.node.value.expression.object.type === 'Identifier') {
                    return true;
                }
            }
        }
    }
    return false;
};
exports.isForwardRef = isForwardRef;
const getForwardRefs = (path, scope) => {
    if (!(0, exports.isForwardRef)(path))
        return;
    const expr = path.node.value;
    const memb = expr.expression;
    const iden = memb.object;
    const prop = memb.property;
    // TODO
    // TODO
    // TODO
    // TODO get the current component props name as a variable
    // THIS means you can have MyComponent(myProps) vs Component(props)
    if (iden.name !== 'props')
        return;
    if (prop.type !== 'Identifier')
        return;
    const name = prop.name;
    if (scope.currentComponent().hasRef(name))
        return;
    scope.currentComponent().addRef({
        name,
        forward: true
    });
};
exports.getForwardRefs = getForwardRefs;
const processForwardRefs = (path, scope) => {
    if (!(0, exports.isForwardRef)(path))
        return;
    const expr = path.node.value;
    const memb = expr.expression;
    const iden = memb.object;
    const prop = memb.property;
    // TODO
    // TODO
    // TODO
    // TODO get the current component props name as a variable
    // THIS means you can have MyComponent(myProps) vs Component(props)
    if (iden.name !== 'props')
        return;
    if (prop.type !== 'Identifier')
        return;
    const name = prop.name;
    if (!scope.currentComponent().hasRef(name))
        return;
    path.replaceWith(t.jsxAttribute(t.jsxIdentifier('ref'), t.jsxExpressionContainer(t.logicalExpression('??', memb, prop // COPY property
    ))));
};
exports.processForwardRefs = processForwardRefs;
const updateRefFunctionDeclarations = (path, scope) => {
    if (!(0, component_1.isTopLevelFunctionDeclaration)(path))
        return;
    const current = scope.currentComponent(true);
    if (!current.hasForwardRef())
        return;
    const ref = current.findForwardRef();
    if (path.parentPath.node.type === 'ExportDefaultDeclaration') {
        if (path.node.id.type !== 'Identifier')
            return;
        scope.defaultForwardRefExport = path.node.id.name;
        const params = path.node.params;
        if (params.length !== 1) {
            (0, utils_1.throwError)('forwardRefs require one property, props!');
        }
        if (params[0].type !== 'Identifier') {
            (0, utils_1.throwError)('forwardRefs require one Identifier, props!');
        }
        const id = params[0];
        let typeRef;
        if (id.typeAnnotation && id.typeAnnotation.type === 'TSTypeAnnotation') {
            typeRef = id.typeAnnotation.typeAnnotation;
        }
        const refIdent = t.identifier(ref.name);
        refIdent.typeAnnotation = t.tsTypeAnnotation(t.tsIndexedAccessType(typeRef, t.tsLiteralType(t.stringLiteral(ref.name))));
        const callExpr = t.callExpression(t.identifier('forwardRef'), [
            t.functionExpression(t.identifier(path.node.id.name), [
                ...path.node.params,
                refIdent
            ], path.node.body, path.node.generator, path.node.async)
        ]);
        callExpr.typeParameters = t.tsTypeParameterInstantiation([
            t.tsAnyKeyword(),
            typeRef
        ]);
        path.parentPath.replaceWith(t.variableDeclaration('const', [
            t.variableDeclarator(t.identifier(path.node.id.name), callExpr)
        ]));
    }
};
exports.updateRefFunctionDeclarations = updateRefFunctionDeclarations;
