"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fileToAst = exports.makeSetState = exports.throwError = void 0;
const fs_1 = require("fs");
const parser_1 = require("@babel/parser");
const throwError = (str) => {
    throw new Error(`Genomic Parser Error: ${str}`);
};
exports.throwError = throwError;
const makeSetState = (name) => {
    return `set${name.charAt(0).toUpperCase() + name.slice(1)}`;
};
exports.makeSetState = makeSetState;
const fileToAst = (path, parserOptions = {
    sourceType: 'module',
    plugins: [
        'jsx', 'typescript'
    ]
}) => {
    return (0, parser_1.parse)((0, fs_1.readFileSync)(path, 'utf-8'), parserOptions);
};
exports.fileToAst = fileToAst;
