import generate from '@babel/generator';
import { throwError } from '../../utils';
export const getConfigOptions = (path, scope) => {
    let configOptions = {};
    const expr = path.node.expression;
    if (expr.type === 'CallExpression' &&
        expr.callee.type === 'Identifier' &&
        expr.callee.name === 'useMetadata') {
        if (path.parent.type !== 'Program') {
            throwError('bad config placement');
        }
        if (expr.arguments.length === 0) {
            throwError('no config args');
        }
        if (expr.arguments.length !== 1) {
            throwError('too many config args');
        }
        if (expr.arguments[0].type !== 'ObjectExpression') {
            throwError('config must be an object');
        }
        try {
            // eval isn't always evil ;) compile time!
            eval(`configOptions = ${generate(expr.arguments[0]).code}`);
        }
        catch (e) {
            throw new Error('Genonomic Parser Error: bad config options');
        }
        path.remove();
        path.stop();
    }
    scope.configOptions = configOptions;
    return configOptions;
};
