import * as t from '@babel/types';
import traverse from '@babel/traverse';
import { throwError } from '../../utils';
export const parseLoops = (path, scope) => {
    if (path.node.openingElement.type !== 'JSXOpeningElement')
        return;
    if (path.node.openingElement.name.type !== 'JSXIdentifier')
        return;
    if (path.node.openingElement.name.name !== 'For')
        return;
    if (path.node.openingElement.attributes[0].type !== 'JSXAttribute')
        return;
    const el = path.node.openingElement.attributes[0];
    if (el.name.type !== 'JSXIdentifier')
        return;
    if (el.name.name !== 'each') {
        throwError('For requires each prop!');
    }
    const exprContainer = el.value;
    /////
    /////
    /////
    const innerExprContainer = path.node.children.find(n => n.type === 'JSXExpressionContainer');
    // RECURSION
    // base recursion case
    if (!innerExprContainer)
        return;
    if (innerExprContainer.type !== 'JSXExpressionContainer') {
        throwError('For requires JSXExpressionContainer!');
    }
    const innerExpr = innerExprContainer.expression;
    if (innerExpr.params.length !== 2) {
        throwError('For requires 2 params!');
    }
    const item = innerExpr.params[0];
    const index = innerExpr.params[1];
    const body = innerExpr.body;
    const expr = t.optionalCallExpression(t.optionalMemberExpression(exprContainer.expression, t.identifier('map'), false, true), [
        t.arrowFunctionExpression([
            item,
            index
        ], body)
    ], false);
    return path.replaceWith(t.jsxExpressionContainer(expr));
    // RECURSION
    // RECURSION
    // RECURSION
    const programNode = t.file(t.program([
        t.functionDeclaration(t.identifier('fakeFunction'), [], t.blockStatement([
            t.returnStatement(
            // RECURSION
            // JSX goes here
            expr)
        ]))
    ]));
    // bake
    traverse(programNode, {
        JSXElement(returnPath) {
            parseLoops(returnPath, scope);
        }
    });
    // pull out of the oven
    const funcDecl = programNode.program.body[0];
    const blockStm = funcDecl.body;
    const retnStmt = blockStm.body[0];
    const output = t.jsxExpressionContainer(retnStmt.argument);
    path.replaceWith(output);
};
