import { readFileSync } from 'fs';
import { parse, ParserOptions } from '@babel/parser';

export const throwError = (str) => {
    throw new Error(`Parser Error: ${str}`);
}

export const fileToAst = (path: string, parserOptions: ParserOptions = {
    sourceType: 'module',
    plugins: [
        'jsx', 'typescript'
    ]
}) => {
    return strToAst(readFileSync(path, 'utf-8'), parserOptions);
};

export const strToAst = (str: string, parserOptions: ParserOptions = {
    sourceType: 'module',
    plugins: [
        'jsx', 'typescript'
    ]
}) => {
    return parse(str, parserOptions);
};

